<template>
  <Dialog v-model="dialogVisible" :title="dialogTitle" width="400">
    <el-form
      ref="formRef"
      v-loading="formLoading"
      :model="formData"
      :rules="formRules"
      label-width="120px"
    >
      <el-form-item
        :label="props.tabPosition === 'craft' ? '工艺名称' : '设备名称'"
        prop="machineryName"
      >
        <el-input v-model="formData.machineryName" placeholder="请输入名称" />
      </el-form-item>
      <el-form-item label="岗位" prop="workstationId">
        <el-tree-select
          v-model="formData.workstationId"
          :data="workstationOptions"
          :props="{ label: 'workstationName', value: 'id', children: 'children' }"
          placeholder="选择岗位"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="所属电柜" prop="lotoId">
        <el-select v-model="formData.lotoId" placeholder="请选择所属电柜" class="!w-300px">
          <el-option
            v-for="dict in lotoOptions"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item
        :label="props.tabPosition === 'craft' ? '工艺图' : '设备图'"
        prop="machineryImg"
      >
        <UploadImg v-model="formData.machineryImg" :limit="1" height="75px" width="75px" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button :disabled="formLoading" type="primary" @click="submitForm">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>

<script lang="ts" setup>
import { ref, reactive, watch, onMounted } from 'vue'
import { handleTree } from '@/utils/tree'
import * as TechnologyApi from '@/api/dv/technology'
import * as MarsDeptApi from '@/api/system/marsdept'
import * as LotoApi from '@/api/dv/lotoStation'

defineOptions({ name: 'TechnologyForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中
const formType = ref('') // 表单的类型：create - 新增；update - 修改

const props = defineProps({
  tabPosition: {
    type: String,
    default: 'craft'
  }
})
const formData = ref({
  machineryId: undefined,
  parentId: 0,
  machineryName: '',
  machineryType: undefined,
  workstationId: undefined,
  lotoId: undefined,
  machineryImg: ''
})

const formRules = reactive({
  machineryName: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
  workstationId: [{ required: true, message: '岗位不能为空', trigger: 'change' }],
  lotoId: [{ required: true, message: '电柜不能为空', trigger: 'change' }]
})

const formRef = ref() // 表单 Ref
const workstationOptions = ref([]) // 岗位树选项
const lotoOptions = ref([]) // 电柜选项


/** 打开弹窗 */
const open = async (type: string, id?: number,tabPosition?:string) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  formData.value.machineryType=tabPosition === 'craft' ? '工艺' : '设备'
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TechnologyApi.getTechnologyInfo(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value
    formData.value.parentId = 0
    formData.value.machineryType='工艺'
    if (formType.value === 'create') {
      await TechnologyApi.addTechnology(data)
      message.success(t('common.createSuccess'))
    } else {
      await TechnologyApi.updateTechnology(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    machineryId: undefined,
    parentId: undefined,
    machineryName: '',
    machineryType: undefined,
    workstationId: undefined,
    lotoId: undefined,
    machineryImg: ''
  }
  formRef.value?.resetFields()
}

// 监听岗位变化
watch(
  () => formData.value.workstationId,
  async (newVal) => {
    if (newVal) {
      const data = { pageNo: 1, pageSize: -1, workstationId: newVal }
      const response = await LotoApi.listLoto(data)
      lotoOptions.value = response.list.map((item) => ({
        value: item.id,
        label: item.lotoName
      }))
    }
  }
)

// 获取岗位树数据
const getWorkstationTree = async () => {
  const data = { pageNo: 1, pageSize: -1 }
  const response = await MarsDeptApi.listMarsDept(data)
  workstationOptions.value = handleTree(response.list, 'id', 'parentId')
}

// 初始化
onMounted(() => {
  getWorkstationTree()
})
</script>
